//+------------------------------------------------------------------+
//|                                                            rsix3 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers  3
#property indicator_color1   DodgerBlue
#property indicator_color2   LimeGreen
#property indicator_color3   Orange
#property indicator_level1   70
#property indicator_level2   50
#property indicator_level3   30

//
//
//
//
//

extern int    timeFrame        = 0;
extern int    RsiPeriod1       = 7;
extern int    RsiPeriod2       = 14;
extern int    RsiPeriod3       = 21;

extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsNotify     = false;
extern bool   alertsEmail      = false;
extern string soundFile        = "alert2.wav";

extern bool   arrowsVisible    = true;
extern string arrowsIdentifier = "rsi Arrows1";
extern double arrowsDisplaceUp = 1.0;
extern double arrowsDisplaceDn = 0.5;
extern color  arrowsUpColor    = DeepSkyBlue;
extern color  arrowsDnColor    = Red;
extern int    arrowsUpCode     = 233;
extern int    arrowsDnCode     = 234;
extern int    arrowsUpSize     = 1;
extern int    arrowsDnSize     = 1;

//
//
//
//
//

double rsi1[];
double rsi2[];
double rsi3[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   timeFrame = MathMax(timeFrame,_Period);
   IndicatorBuffers(4);
      SetIndexBuffer(0,rsi1);
      SetIndexBuffer(1,rsi2);
      SetIndexBuffer(2,rsi3);
      SetIndexBuffer(3,trend);
         RsiPeriod1 = MathMax(RsiPeriod1,1);
         RsiPeriod2 = MathMax(RsiPeriod2,1);
         RsiPeriod3 = MathMax(RsiPeriod3,1);
   
         
   IndicatorShortName("RSIx3 ("+RsiPeriod1+","+RsiPeriod2+","+RsiPeriod3+")");
   return(0);
}
int deinit()
{
   deleteArrows(); 
   
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(MathMax(Bars-counted_bars,3*timeFrame/_Period),Bars-1);

   //
   //
   //
   //
   //
   //

   for (i=limit; i >= 0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      rsi1[i]  = iRSI(NULL,timeFrame,RsiPeriod1,PRICE_CLOSE,y);
      rsi2[i]  = iRSI(NULL,timeFrame,RsiPeriod2,PRICE_CLOSE,y);
      rsi3[i]  = iRSI(NULL,timeFrame,RsiPeriod3,PRICE_CLOSE,y);
         trend[i] = 0;
            if (rsi1[i]>rsi2[i] && rsi2[i]>rsi3[i] && rsi1[i]>50 && rsi2[i]>50 && rsi3[i]>50) trend[i]= 1;
            if (rsi1[i]<rsi2[i] && rsi2[i]<rsi3[i] && rsi1[i]<50 && rsi2[i]<50 && rsi3[i]<50) trend[i]=-1;
            manageArrow(i); 
    }
    
    //
    //
    //
    //
    //
      
    if (alertsOn)
    {
       if (alertsOnCurrent)
            int whichBar = 0;
       else     whichBar = 1;
       if (trend[whichBar] != trend[whichBar+1])
       if (trend[whichBar] == 1)
             doAlert("Buy");
       else  doAlert("Sell");       
    }

return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(timeFrame+" "+Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," RSIx3 ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," RSIx3 " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," RSIx3 "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
     if (trend[i] != trend[i+1])
     {
       deleteArrow(Time[i]);
       if (trend[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,arrowsUpSize,false);
       if (trend[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode,arrowsDnSize,true);
     }                                            
      
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,int theSize, bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode );
         ObjectSet(name,OBJPROP_COLOR,    theColor);
         ObjectSet(name,OBJPROP_WIDTH,    theSize );      
         
         if (up)
              ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsDisplaceDn * gap);      
         else ObjectSet(name,OBJPROP_PRICE1, Low[i] - arrowsDisplaceUp * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}


